Package com.io7m.idstore.server.api

# Record Class IdServerPasswordExpirationConfiguration

java.lang.Object
java.lang.Record
com.io7m.idstore.server.api.IdServerPasswordExpirationConfiguration

Record Components:
  `userPasswordValidityDuration` - The duration for which user passwords are valid
  `adminPasswordValidityDuration` - The duration for which admin passwords are valid

public record IdServerPasswordExpirationConfiguration(Optional<Duration> userPasswordValidityDuration, Optional<Duration> adminPasswordValidityDuration) extends Record
Configuration options relating to password expiration.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `IdServerPasswordExpirationConfiguration(Optional<Duration> userPasswordValidityDuration, Optional<Duration> adminPasswordValidityDuration)`
  Configuration options relating to password expiration.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Optional<Duration>`
  `adminPasswordValidityDuration()`
  Returns the value of the `adminPasswordValidityDuration` record component.
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `IdPassword`
  `expireAdminPasswordIfNecessary(Clock clock, IdPassword password)`
  Take the given password and apply an expiration date to it based on the current clock and settings.
  `IdPassword`
  `expireUserPasswordIfNecessary(Clock clock, IdPassword password)`
  Take the given password and apply an expiration date to it based on the current clock and settings.
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `final String`
  `toString()`
  Returns a string representation of this record class.
  `Optional<Duration>`
  `userPasswordValidityDuration()`
  Returns the value of the `userPasswordValidityDuration` record component.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### IdServerPasswordExpirationConfiguration

    public IdServerPasswordExpirationConfiguration(Optional<Duration> userPasswordValidityDuration, Optional<Duration> adminPasswordValidityDuration)
    Configuration options relating to password expiration.
    Parameters:
      `userPasswordValidityDuration` - The duration for which user passwords are valid
      `adminPasswordValidityDuration` - The duration for which admin passwords are valid

- ## Method Details

  - ### expireUserPasswordIfNecessary

    public IdPassword expireUserPasswordIfNecessary(Clock clock, IdPassword password)
    Take the given password and apply an expiration date to it based on the current clock and settings.
    Parameters:
      `clock` - The clock
      `password` - The password
    Returns:
      The password with a new expiration date

  - ### expireAdminPasswordIfNecessary

    public IdPassword expireAdminPasswordIfNecessary(Clock clock, IdPassword password)
    Take the given password and apply an expiration date to it based on the current clock and settings.
    Parameters:
      `clock` - The clock
      `password` - The password
    Returns:
      The password with a new expiration date

  - ### toString

    public final String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. All components in this record class are compared with `Objects::equals(Object,Object)`.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### userPasswordValidityDuration

    public Optional<Duration> userPasswordValidityDuration()
    Returns the value of the `userPasswordValidityDuration` record component.
    Returns:
      the value of the `userPasswordValidityDuration` record component

  - ### adminPasswordValidityDuration

    public Optional<Duration> adminPasswordValidityDuration()
    Returns the value of the `adminPasswordValidityDuration` record component.
    Returns:
      the value of the `adminPasswordValidityDuration` record component